<?php namespace PHPMaker2020\hostelmgr20; ?>
<?php

/**
 * Table class for inspection
 */
class inspection extends DbTable
{
	protected $SqlFrom = "";
	protected $SqlSelect = "";
	protected $SqlSelectList = "";
	protected $SqlWhere = "";
	protected $SqlGroupBy = "";
	protected $SqlHaving = "";
	protected $SqlOrderBy = "";
	public $UseSessionForListSql = TRUE;

	// Column CSS classes
	public $LeftColumnClass = "col-sm-2 col-form-label ew-label";
	public $RightColumnClass = "col-sm-10";
	public $OffsetColumnClass = "col-sm-10 offset-sm-2";
	public $TableLeftColumnClass = "w-col-2";

	// Export
	public $ExportDoc;

	// Fields
	public $id;
	public $Date;
	public $Time;
	public $Hostel;
	public $Floor;
	public $Room_No;
	public $Room;
	public $Bath_Room;
	public $Wall;
	public $Updatedby;
	public $Light;
	public $Fan;
	public $_Switch;
	public $Door;
	public $Window;
	public $Furniture;
	public $Fur_remarks;

	// Constructor
	public function __construct()
	{
		global $Language, $CurrentLanguage;
		parent::__construct();

		// Language object
		if (!isset($Language))
			$Language = new Language();
		$this->TableVar = 'inspection';
		$this->TableName = 'inspection';
		$this->TableType = 'TABLE';

		// Update Table
		$this->UpdateTable = "`inspection`";
		$this->Dbid = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PhpSpreadsheet only)
		$this->ExportExcelPageSize = ""; // Page size (PhpSpreadsheet only)
		$this->ExportWordPageOrientation = "portrait"; // Page orientation (PHPWord only)
		$this->ExportWordColumnWidth = NULL; // Cell width (PHPWord only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 5;
		$this->AllowAddDeleteRow = TRUE; // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new BasicSearch($this->TableVar);

		// id
		$this->id = new DbField('inspection', 'inspection', 'x_id', 'id', '`id`', '`id`', 3, 11, -1, FALSE, '`id`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->id->IsAutoIncrement = TRUE; // Autoincrement field
		$this->id->IsPrimaryKey = TRUE; // Primary key field
		$this->id->Sortable = TRUE; // Allow sort
		$this->id->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['id'] = &$this->id;

		// Date
		$this->Date = new DbField('inspection', 'inspection', 'x_Date', 'Date', '`Date`', CastDateFieldForLike("`Date`", 0, "DB"), 133, 10, 0, FALSE, '`Date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Date->Nullable = FALSE; // NOT NULL field
		$this->Date->Required = TRUE; // Required field
		$this->Date->Sortable = TRUE; // Allow sort
		$this->Date->DefaultErrorMessage = str_replace("%s", $GLOBALS["DATE_FORMAT"], $Language->phrase("IncorrectDate"));
		$this->fields['Date'] = &$this->Date;

		// Time
		$this->Time = new DbField('inspection', 'inspection', 'x_Time', 'Time', '`Time`', CastDateFieldForLike("`Time`", 4, "DB"), 134, 10, 4, FALSE, '`Time`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Time->Nullable = FALSE; // NOT NULL field
		$this->Time->Required = TRUE; // Required field
		$this->Time->Sortable = TRUE; // Allow sort
		$this->Time->DefaultErrorMessage = str_replace("%s", $GLOBALS["TIME_SEPARATOR"], $Language->phrase("IncorrectTime"));
		$this->fields['Time'] = &$this->Time;

		// Hostel
		$this->Hostel = new DbField('inspection', 'inspection', 'x_Hostel', 'Hostel', '`Hostel`', '`Hostel`', 3, 11, -1, FALSE, '`Hostel`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->Hostel->Nullable = FALSE; // NOT NULL field
		$this->Hostel->Required = TRUE; // Required field
		$this->Hostel->Sortable = TRUE; // Allow sort
		$this->Hostel->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->Hostel->PleaseSelectText = $Language->phrase("PleaseSelect"); // "PleaseSelect" text
		$this->Hostel->Lookup = new Lookup('Hostel', 'hostel', FALSE, 'id', ["Hostel_Name","","",""], [], ["x_Floor"], [], [], [], [], '', '');
		$this->Hostel->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Hostel'] = &$this->Hostel;

		// Floor
		$this->Floor = new DbField('inspection', 'inspection', 'x_Floor', 'Floor', '`Floor`', '`Floor`', 3, 11, -1, FALSE, '`Floor`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->Floor->Nullable = FALSE; // NOT NULL field
		$this->Floor->Required = TRUE; // Required field
		$this->Floor->Sortable = TRUE; // Allow sort
		$this->Floor->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->Floor->PleaseSelectText = $Language->phrase("PleaseSelect"); // "PleaseSelect" text
		$this->Floor->Lookup = new Lookup('Floor', 'floor', FALSE, 'id', ["Floor","","",""], ["x_Hostel"], ["x_Room_No"], ["Hostel_Name"], ["x_Hostel_Name"], [], [], '', '');
		$this->Floor->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Floor'] = &$this->Floor;

		// Room_No
		$this->Room_No = new DbField('inspection', 'inspection', 'x_Room_No', 'Room_No', '`Room_No`', '`Room_No`', 3, 11, -1, FALSE, '`Room_No`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->Room_No->Nullable = FALSE; // NOT NULL field
		$this->Room_No->Required = TRUE; // Required field
		$this->Room_No->Sortable = TRUE; // Allow sort
		$this->Room_No->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->Room_No->PleaseSelectText = $Language->phrase("PleaseSelect"); // "PleaseSelect" text
		$this->Room_No->Lookup = new Lookup('Room_No', 'rooms', FALSE, 'id', ["Room_No","","",""], ["x_Floor"], [], ["Floor"], ["x_Floor"], [], [], '', '');
		$this->Room_No->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Room_No'] = &$this->Room_No;

		// Room
		$this->Room = new DbField('inspection', 'inspection', 'x_Room', 'Room', '`Room`', '`Room`', 3, 11, -1, FALSE, '`Room`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'RADIO');
		$this->Room->Nullable = FALSE; // NOT NULL field
		$this->Room->Required = TRUE; // Required field
		$this->Room->Sortable = TRUE; // Allow sort
		$this->Room->Lookup = new Lookup('Room', 'inspection', FALSE, '', ["","","",""], [], [], [], [], [], [], '', '');
		$this->Room->OptionCount = 5;
		$this->Room->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Room'] = &$this->Room;

		// Bath_Room
		$this->Bath_Room = new DbField('inspection', 'inspection', 'x_Bath_Room', 'Bath_Room', '`Bath_Room`', '`Bath_Room`', 3, 11, -1, FALSE, '`Bath_Room`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'RADIO');
		$this->Bath_Room->Nullable = FALSE; // NOT NULL field
		$this->Bath_Room->Required = TRUE; // Required field
		$this->Bath_Room->Sortable = TRUE; // Allow sort
		$this->Bath_Room->Lookup = new Lookup('Bath_Room', 'inspection', FALSE, '', ["","","",""], [], [], [], [], [], [], '', '');
		$this->Bath_Room->OptionCount = 5;
		$this->Bath_Room->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Bath_Room'] = &$this->Bath_Room;

		// Wall
		$this->Wall = new DbField('inspection', 'inspection', 'x_Wall', 'Wall', '`Wall`', '`Wall`', 3, 11, -1, FALSE, '`Wall`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'RADIO');
		$this->Wall->Nullable = FALSE; // NOT NULL field
		$this->Wall->Required = TRUE; // Required field
		$this->Wall->Sortable = TRUE; // Allow sort
		$this->Wall->Lookup = new Lookup('Wall', 'inspection', FALSE, '', ["","","",""], [], [], [], [], [], [], '', '');
		$this->Wall->OptionCount = 5;
		$this->Wall->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Wall'] = &$this->Wall;

		// Updatedby
		$this->Updatedby = new DbField('inspection', 'inspection', 'x_Updatedby', 'Updatedby', '`Updatedby`', '`Updatedby`', 200, 55, -1, FALSE, '`Updatedby`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Updatedby->Nullable = FALSE; // NOT NULL field
		$this->Updatedby->Sortable = TRUE; // Allow sort
		$this->fields['Updatedby'] = &$this->Updatedby;

		// Light
		$this->Light = new DbField('inspection', 'inspection', 'x_Light', 'Light', '`Light`', '`Light`', 3, 11, -1, FALSE, '`Light`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Light->Nullable = FALSE; // NOT NULL field
		$this->Light->Required = TRUE; // Required field
		$this->Light->Sortable = TRUE; // Allow sort
		$this->Light->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Light'] = &$this->Light;

		// Fan
		$this->Fan = new DbField('inspection', 'inspection', 'x_Fan', 'Fan', '`Fan`', '`Fan`', 3, 11, -1, FALSE, '`Fan`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Fan->Nullable = FALSE; // NOT NULL field
		$this->Fan->Required = TRUE; // Required field
		$this->Fan->Sortable = TRUE; // Allow sort
		$this->Fan->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Fan'] = &$this->Fan;

		// Switch
		$this->_Switch = new DbField('inspection', 'inspection', 'x__Switch', 'Switch', '`Switch`', '`Switch`', 3, 11, -1, FALSE, '`Switch`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->_Switch->Nullable = FALSE; // NOT NULL field
		$this->_Switch->Required = TRUE; // Required field
		$this->_Switch->Sortable = TRUE; // Allow sort
		$this->_Switch->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Switch'] = &$this->_Switch;

		// Door
		$this->Door = new DbField('inspection', 'inspection', 'x_Door', 'Door', '`Door`', '`Door`', 3, 11, -1, FALSE, '`Door`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Door->Nullable = FALSE; // NOT NULL field
		$this->Door->Required = TRUE; // Required field
		$this->Door->Sortable = TRUE; // Allow sort
		$this->Door->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Door'] = &$this->Door;

		// Window
		$this->Window = new DbField('inspection', 'inspection', 'x_Window', 'Window', '`Window`', '`Window`', 3, 11, -1, FALSE, '`Window`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Window->Nullable = FALSE; // NOT NULL field
		$this->Window->Required = TRUE; // Required field
		$this->Window->Sortable = TRUE; // Allow sort
		$this->Window->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Window'] = &$this->Window;

		// Furniture
		$this->Furniture = new DbField('inspection', 'inspection', 'x_Furniture', 'Furniture', '`Furniture`', '`Furniture`', 3, 11, -1, FALSE, '`Furniture`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Furniture->Nullable = FALSE; // NOT NULL field
		$this->Furniture->Required = TRUE; // Required field
		$this->Furniture->Sortable = TRUE; // Allow sort
		$this->Furniture->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
		$this->fields['Furniture'] = &$this->Furniture;

		// Fur_remarks
		$this->Fur_remarks = new DbField('inspection', 'inspection', 'x_Fur_remarks', 'Fur_remarks', '`Fur_remarks`', '`Fur_remarks`', 200, 99, -1, FALSE, '`Fur_remarks`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->Fur_remarks->Sortable = TRUE; // Allow sort
		$this->fields['Fur_remarks'] = &$this->Fur_remarks;
	}

	// Field Visibility
	public function getFieldVisibility($fldParm)
	{
		global $Security;
		return $this->$fldParm->Visible; // Returns original value
	}

	// Set left column class (must be predefined col-*-* classes of Bootstrap grid system)
	function setLeftColumnClass($class)
	{
		if (preg_match('/^col\-(\w+)\-(\d+)$/', $class, $match)) {
			$this->LeftColumnClass = $class . " col-form-label ew-label";
			$this->RightColumnClass = "col-" . $match[1] . "-" . strval(12 - (int)$match[2]);
			$this->OffsetColumnClass = $this->RightColumnClass . " " . str_replace("col-", "offset-", $class);
			$this->TableLeftColumnClass = preg_replace('/^col-\w+-(\d+)$/', "w-col-$1", $class); // Change to w-col-*
		}
	}

	// Single column sort
	public function updateSort(&$fld)
	{
		if ($this->CurrentOrder == $fld->Name) {
			$sortField = $fld->Expression;
			$lastSort = $fld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$thisSort = $this->CurrentOrderType;
			} else {
				$thisSort = ($lastSort == "ASC") ? "DESC" : "ASC";
			}
			$fld->setSort($thisSort);
			$this->setSessionOrderBy($sortField . " " . $thisSort); // Save to Session
		} else {
			$fld->setSort("");
		}
	}

	// Table level SQL
	public function getSqlFrom() // From
	{
		return ($this->SqlFrom != "") ? $this->SqlFrom : "`inspection`";
	}
	public function sqlFrom() // For backward compatibility
	{
		return $this->getSqlFrom();
	}
	public function setSqlFrom($v)
	{
		$this->SqlFrom = $v;
	}
	public function getSqlSelect() // Select
	{
		return ($this->SqlSelect != "") ? $this->SqlSelect : "SELECT * FROM " . $this->getSqlFrom();
	}
	public function sqlSelect() // For backward compatibility
	{
		return $this->getSqlSelect();
	}
	public function setSqlSelect($v)
	{
		$this->SqlSelect = $v;
	}
	public function getSqlWhere() // Where
	{
		$where = ($this->SqlWhere != "") ? $this->SqlWhere : "";
		$this->TableFilter = "";
		AddFilter($where, $this->TableFilter);
		return $where;
	}
	public function sqlWhere() // For backward compatibility
	{
		return $this->getSqlWhere();
	}
	public function setSqlWhere($v)
	{
		$this->SqlWhere = $v;
	}
	public function getSqlGroupBy() // Group By
	{
		return ($this->SqlGroupBy != "") ? $this->SqlGroupBy : "";
	}
	public function sqlGroupBy() // For backward compatibility
	{
		return $this->getSqlGroupBy();
	}
	public function setSqlGroupBy($v)
	{
		$this->SqlGroupBy = $v;
	}
	public function getSqlHaving() // Having
	{
		return ($this->SqlHaving != "") ? $this->SqlHaving : "";
	}
	public function sqlHaving() // For backward compatibility
	{
		return $this->getSqlHaving();
	}
	public function setSqlHaving($v)
	{
		$this->SqlHaving = $v;
	}
	public function getSqlOrderBy() // Order By
	{
		return ($this->SqlOrderBy != "") ? $this->SqlOrderBy : "";
	}
	public function sqlOrderBy() // For backward compatibility
	{
		return $this->getSqlOrderBy();
	}
	public function setSqlOrderBy($v)
	{
		$this->SqlOrderBy = $v;
	}

	// Apply User ID filters
	public function applyUserIDFilters($filter)
	{
		return $filter;
	}

	// Check if User ID security allows view all
	public function userIDAllow($id = "")
	{
		$allow = Config("USER_ID_ALLOW");
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get recordset
	public function getRecordset($sql, $rowcnt = -1, $offset = -1)
	{
		$conn = $this->getConnection();
		$conn->raiseErrorFn = Config("ERROR_FUNC");
		$rs = $conn->selectLimit($sql, $rowcnt, $offset);
		$conn->raiseErrorFn = "";
		return $rs;
	}

	// Get record count
	public function getRecordCount($sql, $c = NULL)
	{
		$cnt = -1;
		$rs = NULL;
		$sql = preg_replace('/\/\*BeginOrderBy\*\/[\s\S]+\/\*EndOrderBy\*\//', "", $sql); // Remove ORDER BY clause (MSSQL)
		$pattern = '/^SELECT\s([\s\S]+)\sFROM\s/i';

		// Skip Custom View / SubQuery / SELECT DISTINCT / ORDER BY
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') &&
			preg_match($pattern, $sql) && !preg_match('/\(\s*(SELECT[^)]+)\)/i', $sql) &&
			!preg_match('/^\s*select\s+distinct\s+/i', $sql) && !preg_match('/\s+order\s+by\s+/i', $sql)) {
			$sqlwrk = "SELECT COUNT(*) FROM " . preg_replace($pattern, "", $sql);
		} else {
			$sqlwrk = "SELECT COUNT(*) FROM (" . $sql . ") COUNT_TABLE";
		}
		$conn = $c ?: $this->getConnection();
		if ($rs = $conn->execute($sqlwrk)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->close();
			}
			return (int)$cnt;
		}

		// Unable to get count, get record count directly
		if ($rs = $conn->execute($sql)) {
			$cnt = $rs->RecordCount();
			$rs->close();
			return (int)$cnt;
		}
		return $cnt;
	}

	// Get SQL
	public function getSql($where, $orderBy = "")
	{
		return BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderBy);
	}

	// Table SQL
	public function getCurrentSql()
	{
		$filter = $this->CurrentFilter;
		$filter = $this->applyUserIDFilters($filter);
		$sort = $this->getSessionOrderBy();
		return $this->getSql($filter, $sort);
	}

	// Table SQL with List page filter
	public function getListSql()
	{
		$filter = $this->UseSessionForListSql ? $this->getSessionWhere() : "";
		AddFilter($filter, $this->CurrentFilter);
		$filter = $this->applyUserIDFilters($filter);
		$this->Recordset_Selecting($filter);
		$select = $this->getSqlSelect();
		$sort = $this->UseSessionForListSql ? $this->getSessionOrderBy() : "";
		return BuildSelectSql($select, $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $filter, $sort);
	}

	// Get ORDER BY clause
	public function getOrderBy()
	{
		$sort = $this->getSessionOrderBy();
		return BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sort);
	}

	// Get record count based on filter (for detail record count in master table pages)
	public function loadRecordCount($filter)
	{
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $filter;
		$this->Recordset_Selecting($this->CurrentFilter);
		$select = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlSelect() : "SELECT * FROM " . $this->getSqlFrom();
		$groupBy = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlGroupBy() : "";
		$having = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlHaving() : "";
		$sql = BuildSelectSql($select, $this->getSqlWhere(), $groupBy, $having, "", $this->CurrentFilter, "");
		$cnt = $this->getRecordCount($sql);
		$this->CurrentFilter = $origFilter;
		return $cnt;
	}

	// Get record count (for current List page)
	public function listRecordCount()
	{
		$filter = $this->getSessionWhere();
		AddFilter($filter, $this->CurrentFilter);
		$filter = $this->applyUserIDFilters($filter);
		$this->Recordset_Selecting($filter);
		$select = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlSelect() : "SELECT * FROM " . $this->getSqlFrom();
		$groupBy = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlGroupBy() : "";
		$having = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlHaving() : "";
		$sql = BuildSelectSql($select, $this->getSqlWhere(), $groupBy, $having, "", $filter, "");
		$cnt = $this->getRecordCount($sql);
		return $cnt;
	}

	// INSERT statement
	protected function insertSql(&$rs)
	{
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->IsCustom)
				continue;
			$names .= $this->fields[$name]->Expression . ",";
			$values .= QuotedValue($value, $this->fields[$name]->DataType, $this->Dbid) . ",";
		}
		$names = preg_replace('/,+$/', "", $names);
		$values = preg_replace('/,+$/', "", $values);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	public function insert(&$rs)
	{
		$conn = $this->getConnection();
		$success = $conn->execute($this->insertSql($rs));
		if ($success) {

			// Get insert id if necessary
			$this->id->setDbValue($conn->insert_ID());
			$rs['id'] = $this->id->DbValue;
		}
		return $success;
	}

	// UPDATE statement
	protected function updateSql(&$rs, $where = "", $curfilter = TRUE)
	{
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->IsCustom || $this->fields[$name]->IsAutoIncrement)
				continue;
			$sql .= $this->fields[$name]->Expression . "=";
			$sql .= QuotedValue($value, $this->fields[$name]->DataType, $this->Dbid) . ",";
		}
		$sql = preg_replace('/,+$/', "", $sql);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->arrayToFilter($where);
		AddFilter($filter, $where);
		if ($filter != "")
			$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	public function update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE)
	{
		$conn = $this->getConnection();
		$success = $conn->execute($this->updateSql($rs, $where, $curfilter));
		return $success;
	}

	// DELETE statement
	protected function deleteSql(&$rs, $where = "", $curfilter = TRUE)
	{
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->arrayToFilter($where);
		if ($rs) {
			if (array_key_exists('id', $rs))
				AddFilter($where, QuotedName('id', $this->Dbid) . '=' . QuotedValue($rs['id'], $this->id->DataType, $this->Dbid));
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		AddFilter($filter, $where);
		if ($filter != "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	public function delete(&$rs, $where = "", $curfilter = FALSE)
	{
		$success = TRUE;
		$conn = $this->getConnection();
		if ($success)
			$success = $conn->execute($this->deleteSql($rs, $where, $curfilter));
		return $success;
	}

	// Load DbValue from recordset or array
	protected function loadDbValues(&$rs)
	{
		if (!$rs || !is_array($rs) && $rs->EOF)
			return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->id->DbValue = $row['id'];
		$this->Date->DbValue = $row['Date'];
		$this->Time->DbValue = $row['Time'];
		$this->Hostel->DbValue = $row['Hostel'];
		$this->Floor->DbValue = $row['Floor'];
		$this->Room_No->DbValue = $row['Room_No'];
		$this->Room->DbValue = $row['Room'];
		$this->Bath_Room->DbValue = $row['Bath_Room'];
		$this->Wall->DbValue = $row['Wall'];
		$this->Updatedby->DbValue = $row['Updatedby'];
		$this->Light->DbValue = $row['Light'];
		$this->Fan->DbValue = $row['Fan'];
		$this->_Switch->DbValue = $row['Switch'];
		$this->Door->DbValue = $row['Door'];
		$this->Window->DbValue = $row['Window'];
		$this->Furniture->DbValue = $row['Furniture'];
		$this->Fur_remarks->DbValue = $row['Fur_remarks'];
	}

	// Delete uploaded files
	public function deleteUploadedFiles($row)
	{
		$this->loadDbValues($row);
	}

	// Record filter WHERE clause
	protected function sqlKeyFilter()
	{
		return "`id` = @id@";
	}

	// Get record filter
	public function getRecordFilter($row = NULL)
	{
		$keyFilter = $this->sqlKeyFilter();
		if (is_array($row))
			$val = array_key_exists('id', $row) ? $row['id'] : NULL;
		else
			$val = $this->id->OldValue !== NULL ? $this->id->OldValue : $this->id->CurrentValue;
		if (!is_numeric($val))
			return "0=1"; // Invalid key
		if ($val == NULL)
			return "0=1"; // Invalid key
		else
			$keyFilter = str_replace("@id@", AdjustSql($val, $this->Dbid), $keyFilter); // Replace key value
		return $keyFilter;
	}

	// Return page URL
	public function getReturnUrl()
	{
		$name = PROJECT_NAME . "_" . $this->TableVar . "_" . Config("TABLE_RETURN_URL");

		// Get referer URL automatically
		if (ServerVar("HTTP_REFERER") != "" && ReferPageName() != CurrentPageName() && ReferPageName() != "login.php") // Referer not same page or login page
			$_SESSION[$name] = ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] != "") {
			return $_SESSION[$name];
		} else {
			return "inspectionlist.php";
		}
	}
	public function setReturnUrl($v)
	{
		$_SESSION[PROJECT_NAME . "_" . $this->TableVar . "_" . Config("TABLE_RETURN_URL")] = $v;
	}

	// Get modal caption
	public function getModalCaption($pageName)
	{
		global $Language;
		if ($pageName == "inspectionview.php")
			return $Language->phrase("View");
		elseif ($pageName == "inspectionedit.php")
			return $Language->phrase("Edit");
		elseif ($pageName == "inspectionadd.php")
			return $Language->phrase("Add");
		else
			return "";
	}

	// List URL
	public function getListUrl()
	{
		return "inspectionlist.php";
	}

	// View URL
	public function getViewUrl($parm = "")
	{
		if ($parm != "")
			$url = $this->keyUrl("inspectionview.php", $this->getUrlParm($parm));
		else
			$url = $this->keyUrl("inspectionview.php", $this->getUrlParm(Config("TABLE_SHOW_DETAIL") . "="));
		return $this->addMasterUrl($url);
	}

	// Add URL
	public function getAddUrl($parm = "")
	{
		if ($parm != "")
			$url = "inspectionadd.php?" . $this->getUrlParm($parm);
		else
			$url = "inspectionadd.php";
		return $this->addMasterUrl($url);
	}

	// Edit URL
	public function getEditUrl($parm = "")
	{
		$url = $this->keyUrl("inspectionedit.php", $this->getUrlParm($parm));
		return $this->addMasterUrl($url);
	}

	// Inline edit URL
	public function getInlineEditUrl()
	{
		$url = $this->keyUrl(CurrentPageName(), $this->getUrlParm("action=edit"));
		return $this->addMasterUrl($url);
	}

	// Copy URL
	public function getCopyUrl($parm = "")
	{
		$url = $this->keyUrl("inspectionadd.php", $this->getUrlParm($parm));
		return $this->addMasterUrl($url);
	}

	// Inline copy URL
	public function getInlineCopyUrl()
	{
		$url = $this->keyUrl(CurrentPageName(), $this->getUrlParm("action=copy"));
		return $this->addMasterUrl($url);
	}

	// Delete URL
	public function getDeleteUrl()
	{
		return $this->keyUrl("inspectiondelete.php", $this->getUrlParm());
	}

	// Add master url
	public function addMasterUrl($url)
	{
		return $url;
	}
	public function keyToJson($htmlEncode = FALSE)
	{
		$json = "";
		$json .= "id:" . JsonEncode($this->id->CurrentValue, "number");
		$json = "{" . $json . "}";
		if ($htmlEncode)
			$json = HtmlEncode($json);
		return $json;
	}

	// Add key value to URL
	public function keyUrl($url, $parm = "")
	{
		$url = $url . "?";
		if ($parm != "")
			$url .= $parm . "&";
		if ($this->id->CurrentValue != NULL) {
			$url .= "id=" . urlencode($this->id->CurrentValue);
		} else {
			return "javascript:ew.alert(ew.language.phrase('InvalidRecord'));";
		}
		return $url;
	}

	// Sort URL
	public function sortUrl(&$fld)
	{
		if ($this->CurrentAction || $this->isExport() ||
			in_array($fld->Type, [128, 204, 205])) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$urlParm = $this->getUrlParm("order=" . urlencode($fld->Name) . "&amp;ordertype=" . $fld->reverseSort());
			return $this->addMasterUrl(CurrentPageName() . "?" . $urlParm);
		} else {
			return "";
		}
	}

	// Get record keys from Post/Get/Session
	public function getRecordKeys()
	{
		$arKeys = [];
		$arKey = [];
		if (Param("key_m") !== NULL) {
			$arKeys = Param("key_m");
			$cnt = count($arKeys);
		} else {
			if (Param("id") !== NULL)
				$arKeys[] = Param("id");
			elseif (IsApi() && Key(0) !== NULL)
				$arKeys[] = Key(0);
			elseif (IsApi() && Route(2) !== NULL)
				$arKeys[] = Route(2);
			else
				$arKeys = NULL; // Do not setup

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = [];
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				if (!is_numeric($key))
					continue;
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get filter from record keys
	public function getFilterFromRecordKeys($setCurrent = TRUE)
	{
		$arKeys = $this->getRecordKeys();
		$keyFilter = "";
		foreach ($arKeys as $key) {
			if ($keyFilter != "") $keyFilter .= " OR ";
			if ($setCurrent)
				$this->id->CurrentValue = $key;
			else
				$this->id->OldValue = $key;
			$keyFilter .= "(" . $this->getRecordFilter() . ")";
		}
		return $keyFilter;
	}

	// Load rows based on filter
	public function &loadRs($filter)
	{

		// Set up filter (WHERE Clause)
		$sql = $this->getSql($filter);
		$conn = $this->getConnection();
		$rs = $conn->execute($sql);
		return $rs;
	}

	// Load row values from recordset
	public function loadListRowValues(&$rs)
	{
		$this->id->setDbValue($rs->fields('id'));
		$this->Date->setDbValue($rs->fields('Date'));
		$this->Time->setDbValue($rs->fields('Time'));
		$this->Hostel->setDbValue($rs->fields('Hostel'));
		$this->Floor->setDbValue($rs->fields('Floor'));
		$this->Room_No->setDbValue($rs->fields('Room_No'));
		$this->Room->setDbValue($rs->fields('Room'));
		$this->Bath_Room->setDbValue($rs->fields('Bath_Room'));
		$this->Wall->setDbValue($rs->fields('Wall'));
		$this->Updatedby->setDbValue($rs->fields('Updatedby'));
		$this->Light->setDbValue($rs->fields('Light'));
		$this->Fan->setDbValue($rs->fields('Fan'));
		$this->_Switch->setDbValue($rs->fields('Switch'));
		$this->Door->setDbValue($rs->fields('Door'));
		$this->Window->setDbValue($rs->fields('Window'));
		$this->Furniture->setDbValue($rs->fields('Furniture'));
		$this->Fur_remarks->setDbValue($rs->fields('Fur_remarks'));
	}

	// Render list row values
	public function renderListRow()
	{
		global $Security, $CurrentLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// Common render codes
		// id
		// Date
		// Time
		// Hostel
		// Floor
		// Room_No
		// Room
		// Bath_Room
		// Wall
		// Updatedby
		// Light
		// Fan
		// Switch
		// Door
		// Window
		// Furniture
		// Fur_remarks
		// id

		$this->id->ViewValue = $this->id->CurrentValue;
		$this->id->ViewCustomAttributes = "";

		// Date
		$this->Date->ViewValue = $this->Date->CurrentValue;
		$this->Date->ViewValue = FormatDateTime($this->Date->ViewValue, 0);
		$this->Date->ViewCustomAttributes = "";

		// Time
		$this->Time->ViewValue = $this->Time->CurrentValue;
		$this->Time->ViewValue = FormatDateTime($this->Time->ViewValue, 4);
		$this->Time->ViewCustomAttributes = "";

		// Hostel
		$curVal = strval($this->Hostel->CurrentValue);
		if ($curVal != "") {
			$this->Hostel->ViewValue = $this->Hostel->lookupCacheOption($curVal);
			if ($this->Hostel->ViewValue === NULL) { // Lookup from database
				$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
				$sqlWrk = $this->Hostel->Lookup->getSql(FALSE, $filterWrk, '', $this);
				$rswrk = Conn()->execute($sqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$arwrk = [];
					$arwrk[1] = $rswrk->fields('df');
					$this->Hostel->ViewValue = $this->Hostel->displayValue($arwrk);
					$rswrk->Close();
				} else {
					$this->Hostel->ViewValue = $this->Hostel->CurrentValue;
				}
			}
		} else {
			$this->Hostel->ViewValue = NULL;
		}
		$this->Hostel->ViewCustomAttributes = "";

		// Floor
		$curVal = strval($this->Floor->CurrentValue);
		if ($curVal != "") {
			$this->Floor->ViewValue = $this->Floor->lookupCacheOption($curVal);
			if ($this->Floor->ViewValue === NULL) { // Lookup from database
				$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
				$sqlWrk = $this->Floor->Lookup->getSql(FALSE, $filterWrk, '', $this);
				$rswrk = Conn()->execute($sqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$arwrk = [];
					$arwrk[1] = $rswrk->fields('df');
					$this->Floor->ViewValue = $this->Floor->displayValue($arwrk);
					$rswrk->Close();
				} else {
					$this->Floor->ViewValue = $this->Floor->CurrentValue;
				}
			}
		} else {
			$this->Floor->ViewValue = NULL;
		}
		$this->Floor->ViewCustomAttributes = "";

		// Room_No
		$curVal = strval($this->Room_No->CurrentValue);
		if ($curVal != "") {
			$this->Room_No->ViewValue = $this->Room_No->lookupCacheOption($curVal);
			if ($this->Room_No->ViewValue === NULL) { // Lookup from database
				$filterWrk = "`id`" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
				$sqlWrk = $this->Room_No->Lookup->getSql(FALSE, $filterWrk, '', $this);
				$rswrk = Conn()->execute($sqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$arwrk = [];
					$arwrk[1] = FormatNumber($rswrk->fields('df'), 0, -2, -2, -2);
					$this->Room_No->ViewValue = $this->Room_No->displayValue($arwrk);
					$rswrk->Close();
				} else {
					$this->Room_No->ViewValue = $this->Room_No->CurrentValue;
				}
			}
		} else {
			$this->Room_No->ViewValue = NULL;
		}
		$this->Room_No->ViewCustomAttributes = "";

		// Room
		if (strval($this->Room->CurrentValue) != "") {
			$this->Room->ViewValue = $this->Room->optionCaption($this->Room->CurrentValue);
		} else {
			$this->Room->ViewValue = NULL;
		}
		$this->Room->ViewCustomAttributes = "";

		// Bath_Room
		if (strval($this->Bath_Room->CurrentValue) != "") {
			$this->Bath_Room->ViewValue = $this->Bath_Room->optionCaption($this->Bath_Room->CurrentValue);
		} else {
			$this->Bath_Room->ViewValue = NULL;
		}
		$this->Bath_Room->ViewCustomAttributes = "";

		// Wall
		if (strval($this->Wall->CurrentValue) != "") {
			$this->Wall->ViewValue = $this->Wall->optionCaption($this->Wall->CurrentValue);
		} else {
			$this->Wall->ViewValue = NULL;
		}
		$this->Wall->ViewCustomAttributes = "";

		// Updatedby
		$this->Updatedby->ViewValue = $this->Updatedby->CurrentValue;
		$this->Updatedby->ViewCustomAttributes = "";

		// Light
		$this->Light->ViewValue = $this->Light->CurrentValue;
		$this->Light->ViewValue = FormatNumber($this->Light->ViewValue, 0, -2, -2, -2);
		$this->Light->ViewCustomAttributes = "";

		// Fan
		$this->Fan->ViewValue = $this->Fan->CurrentValue;
		$this->Fan->ViewValue = FormatNumber($this->Fan->ViewValue, 0, -2, -2, -2);
		$this->Fan->ViewCustomAttributes = "";

		// Switch
		$this->_Switch->ViewValue = $this->_Switch->CurrentValue;
		$this->_Switch->ViewValue = FormatNumber($this->_Switch->ViewValue, 0, -2, -2, -2);
		$this->_Switch->ViewCustomAttributes = "";

		// Door
		$this->Door->ViewValue = $this->Door->CurrentValue;
		$this->Door->ViewValue = FormatNumber($this->Door->ViewValue, 0, -2, -2, -2);
		$this->Door->ViewCustomAttributes = "";

		// Window
		$this->Window->ViewValue = $this->Window->CurrentValue;
		$this->Window->ViewValue = FormatNumber($this->Window->ViewValue, 0, -2, -2, -2);
		$this->Window->ViewCustomAttributes = "";

		// Furniture
		$this->Furniture->ViewValue = $this->Furniture->CurrentValue;
		$this->Furniture->ViewValue = FormatNumber($this->Furniture->ViewValue, 0, -2, -2, -2);
		$this->Furniture->ViewCustomAttributes = "";

		// Fur_remarks
		$this->Fur_remarks->ViewValue = $this->Fur_remarks->CurrentValue;
		$this->Fur_remarks->ViewCustomAttributes = "";

		// id
		$this->id->LinkCustomAttributes = "";
		$this->id->HrefValue = "";
		$this->id->TooltipValue = "";

		// Date
		$this->Date->LinkCustomAttributes = "";
		$this->Date->HrefValue = "";
		$this->Date->TooltipValue = "";

		// Time
		$this->Time->LinkCustomAttributes = "";
		$this->Time->HrefValue = "";
		$this->Time->TooltipValue = "";

		// Hostel
		$this->Hostel->LinkCustomAttributes = "";
		$this->Hostel->HrefValue = "";
		$this->Hostel->TooltipValue = "";

		// Floor
		$this->Floor->LinkCustomAttributes = "";
		$this->Floor->HrefValue = "";
		$this->Floor->TooltipValue = "";

		// Room_No
		$this->Room_No->LinkCustomAttributes = "";
		$this->Room_No->HrefValue = "";
		$this->Room_No->TooltipValue = "";

		// Room
		$this->Room->LinkCustomAttributes = "";
		$this->Room->HrefValue = "";
		$this->Room->TooltipValue = "";

		// Bath_Room
		$this->Bath_Room->LinkCustomAttributes = "";
		$this->Bath_Room->HrefValue = "";
		$this->Bath_Room->TooltipValue = "";

		// Wall
		$this->Wall->LinkCustomAttributes = "";
		$this->Wall->HrefValue = "";
		$this->Wall->TooltipValue = "";

		// Updatedby
		$this->Updatedby->LinkCustomAttributes = "";
		$this->Updatedby->HrefValue = "";
		$this->Updatedby->TooltipValue = "";

		// Light
		$this->Light->LinkCustomAttributes = "";
		$this->Light->HrefValue = "";
		$this->Light->TooltipValue = "";

		// Fan
		$this->Fan->LinkCustomAttributes = "";
		$this->Fan->HrefValue = "";
		$this->Fan->TooltipValue = "";

		// Switch
		$this->_Switch->LinkCustomAttributes = "";
		$this->_Switch->HrefValue = "";
		$this->_Switch->TooltipValue = "";

		// Door
		$this->Door->LinkCustomAttributes = "";
		$this->Door->HrefValue = "";
		$this->Door->TooltipValue = "";

		// Window
		$this->Window->LinkCustomAttributes = "";
		$this->Window->HrefValue = "";
		$this->Window->TooltipValue = "";

		// Furniture
		$this->Furniture->LinkCustomAttributes = "";
		$this->Furniture->HrefValue = "";
		$this->Furniture->TooltipValue = "";

		// Fur_remarks
		$this->Fur_remarks->LinkCustomAttributes = "";
		$this->Fur_remarks->HrefValue = "";
		$this->Fur_remarks->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();

		// Save data for Custom Template
		$this->Rows[] = $this->customTemplateFieldValues();
	}

	// Render edit row values
	public function renderEditRow()
	{
		global $Security, $CurrentLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// id
		$this->id->EditAttrs["class"] = "form-control";
		$this->id->EditCustomAttributes = "";
		$this->id->EditValue = $this->id->CurrentValue;
		$this->id->ViewCustomAttributes = "";

		// Date
		$this->Date->EditAttrs["class"] = "form-control";
		$this->Date->EditCustomAttributes = "";
		$this->Date->EditValue = FormatDateTime($this->Date->CurrentValue, 8);
		$this->Date->PlaceHolder = RemoveHtml($this->Date->caption());

		// Time
		$this->Time->EditAttrs["class"] = "form-control";
		$this->Time->EditCustomAttributes = "";
		$this->Time->EditValue = $this->Time->CurrentValue;
		$this->Time->PlaceHolder = RemoveHtml($this->Time->caption());

		// Hostel
		$this->Hostel->EditAttrs["class"] = "form-control";
		$this->Hostel->EditCustomAttributes = "";

		// Floor
		$this->Floor->EditAttrs["class"] = "form-control";
		$this->Floor->EditCustomAttributes = "";

		// Room_No
		$this->Room_No->EditAttrs["class"] = "form-control";
		$this->Room_No->EditCustomAttributes = "";

		// Room
		$this->Room->EditCustomAttributes = "";
		$this->Room->EditValue = $this->Room->options(FALSE);

		// Bath_Room
		$this->Bath_Room->EditCustomAttributes = "";
		$this->Bath_Room->EditValue = $this->Bath_Room->options(FALSE);

		// Wall
		$this->Wall->EditCustomAttributes = "";
		$this->Wall->EditValue = $this->Wall->options(FALSE);

		// Updatedby
		// Light

		$this->Light->EditAttrs["class"] = "form-control";
		$this->Light->EditCustomAttributes = "";
		$this->Light->EditValue = $this->Light->CurrentValue;
		$this->Light->PlaceHolder = RemoveHtml($this->Light->caption());

		// Fan
		$this->Fan->EditAttrs["class"] = "form-control";
		$this->Fan->EditCustomAttributes = "";
		$this->Fan->EditValue = $this->Fan->CurrentValue;
		$this->Fan->PlaceHolder = RemoveHtml($this->Fan->caption());

		// Switch
		$this->_Switch->EditAttrs["class"] = "form-control";
		$this->_Switch->EditCustomAttributes = "";
		$this->_Switch->EditValue = $this->_Switch->CurrentValue;
		$this->_Switch->PlaceHolder = RemoveHtml($this->_Switch->caption());

		// Door
		$this->Door->EditAttrs["class"] = "form-control";
		$this->Door->EditCustomAttributes = "";
		$this->Door->EditValue = $this->Door->CurrentValue;
		$this->Door->PlaceHolder = RemoveHtml($this->Door->caption());

		// Window
		$this->Window->EditAttrs["class"] = "form-control";
		$this->Window->EditCustomAttributes = "";
		$this->Window->EditValue = $this->Window->CurrentValue;
		$this->Window->PlaceHolder = RemoveHtml($this->Window->caption());

		// Furniture
		$this->Furniture->EditAttrs["class"] = "form-control";
		$this->Furniture->EditCustomAttributes = "";
		$this->Furniture->EditValue = $this->Furniture->CurrentValue;
		$this->Furniture->PlaceHolder = RemoveHtml($this->Furniture->caption());

		// Fur_remarks
		$this->Fur_remarks->EditAttrs["class"] = "form-control";
		$this->Fur_remarks->EditCustomAttributes = "";
		if (!$this->Fur_remarks->Raw)
			$this->Fur_remarks->CurrentValue = HtmlDecode($this->Fur_remarks->CurrentValue);
		$this->Fur_remarks->EditValue = $this->Fur_remarks->CurrentValue;
		$this->Fur_remarks->PlaceHolder = RemoveHtml($this->Fur_remarks->caption());

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	public function aggregateListRowValues()
	{
	}

	// Aggregate list row (for rendering)
	public function aggregateListRow()
	{

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	public function exportDocument($doc, $recordset, $startRec = 1, $stopRec = 1, $exportPageType = "")
	{
		if (!$recordset || !$doc)
			return;
		if (!$doc->ExportCustom) {

			// Write header
			$doc->exportTableHeader();
			if ($doc->Horizontal) { // Horizontal format, write header
				$doc->beginExportRow();
				if ($exportPageType == "view") {
					$doc->exportCaption($this->id);
					$doc->exportCaption($this->Date);
					$doc->exportCaption($this->Time);
					$doc->exportCaption($this->Hostel);
					$doc->exportCaption($this->Floor);
					$doc->exportCaption($this->Room_No);
					$doc->exportCaption($this->Room);
					$doc->exportCaption($this->Bath_Room);
					$doc->exportCaption($this->Wall);
					$doc->exportCaption($this->Updatedby);
					$doc->exportCaption($this->Light);
					$doc->exportCaption($this->Fan);
					$doc->exportCaption($this->_Switch);
					$doc->exportCaption($this->Door);
					$doc->exportCaption($this->Window);
					$doc->exportCaption($this->Furniture);
					$doc->exportCaption($this->Fur_remarks);
				} else {
					$doc->exportCaption($this->id);
					$doc->exportCaption($this->Date);
					$doc->exportCaption($this->Time);
					$doc->exportCaption($this->Hostel);
					$doc->exportCaption($this->Floor);
					$doc->exportCaption($this->Room_No);
					$doc->exportCaption($this->Room);
					$doc->exportCaption($this->Bath_Room);
					$doc->exportCaption($this->Wall);
					$doc->exportCaption($this->Updatedby);
					$doc->exportCaption($this->Light);
					$doc->exportCaption($this->Fan);
					$doc->exportCaption($this->_Switch);
					$doc->exportCaption($this->Door);
					$doc->exportCaption($this->Window);
					$doc->exportCaption($this->Furniture);
					$doc->exportCaption($this->Fur_remarks);
				}
				$doc->endExportRow();
			}
		}

		// Move to first record
		$recCnt = $startRec - 1;
		if (!$recordset->EOF) {
			$recordset->moveFirst();
			if ($startRec > 1)
				$recordset->move($startRec - 1);
		}
		while (!$recordset->EOF && $recCnt < $stopRec) {
			$recCnt++;
			if ($recCnt >= $startRec) {
				$rowCnt = $recCnt - $startRec + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($rowCnt > 1 && ($rowCnt - 1) % $this->ExportPageBreakCount == 0)
						$doc->exportPageBreak();
				}
				$this->loadListRowValues($recordset);

				// Render row
				$this->RowType = ROWTYPE_VIEW; // Render view
				$this->resetAttributes();
				$this->renderListRow();
				if (!$doc->ExportCustom) {
					$doc->beginExportRow($rowCnt); // Allow CSS styles if enabled
					if ($exportPageType == "view") {
						$doc->exportField($this->id);
						$doc->exportField($this->Date);
						$doc->exportField($this->Time);
						$doc->exportField($this->Hostel);
						$doc->exportField($this->Floor);
						$doc->exportField($this->Room_No);
						$doc->exportField($this->Room);
						$doc->exportField($this->Bath_Room);
						$doc->exportField($this->Wall);
						$doc->exportField($this->Updatedby);
						$doc->exportField($this->Light);
						$doc->exportField($this->Fan);
						$doc->exportField($this->_Switch);
						$doc->exportField($this->Door);
						$doc->exportField($this->Window);
						$doc->exportField($this->Furniture);
						$doc->exportField($this->Fur_remarks);
					} else {
						$doc->exportField($this->id);
						$doc->exportField($this->Date);
						$doc->exportField($this->Time);
						$doc->exportField($this->Hostel);
						$doc->exportField($this->Floor);
						$doc->exportField($this->Room_No);
						$doc->exportField($this->Room);
						$doc->exportField($this->Bath_Room);
						$doc->exportField($this->Wall);
						$doc->exportField($this->Updatedby);
						$doc->exportField($this->Light);
						$doc->exportField($this->Fan);
						$doc->exportField($this->_Switch);
						$doc->exportField($this->Door);
						$doc->exportField($this->Window);
						$doc->exportField($this->Furniture);
						$doc->exportField($this->Fur_remarks);
					}
					$doc->endExportRow($rowCnt);
				}
			}

			// Call Row Export server event
			if ($doc->ExportCustom)
				$this->Row_Export($recordset->fields);
			$recordset->moveNext();
		}
		if (!$doc->ExportCustom) {
			$doc->exportTableFooter();
		}
	}

	// Get file data
	public function getFileData($fldparm, $key, $resize, $width = 0, $height = 0)
	{

		// No binary fields
		return FALSE;
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE

		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending($email, &$args) {

		//var_dump($email); var_dump($args); exit();
		return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->Name, $fld->Lookup, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>);

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>